Adding information to an exception?

StackOverflow

I want to achieve something like this:

def foo():
   try:
       raise IOError("Stuff ")
   except:
       raise

def bar(arg1):
    try:
       foo()
    except Exception as e:
       e.message = e.message + "happens at %s" % arg1
       raise

bar("arg1")
Traceback...
  IOError("Stuff Happens at arg1")

But what I get is:

Traceback..
  IOError("Stuff")

Any clues as to how to achieve this? How to do it both in Python 2 and 3?

Answer rating: 168

In case you came here searching for a solution for Python 3 the manual says:

When raising a new exception (rather than using a bare raise to re-raise the exception currently being handled), the implicit exception context can be supplemented with an explicit cause by using from with raise:

raise new_exc from original_exc

Example:

try:
    return [permission() for permission in self.permission_classes]
except TypeError as e:
    raise TypeError("Make sure your view"s "permission_classes" are iterable. "
                    "If you use "()" to generate a set with a single element "
                    "make sure that there is a comma behind the one (element,).") from e

Which looks like this in the end:

2017-09-06 16:50:14,797 [ERROR] django.request: Internal Server Error: /v1/sendEmail/
Traceback (most recent call last):
File "venv/lib/python3.4/site-packages/rest_framework/views.py", line 275, in get_permissions
    return [permission() for permission in self.permission_classes]
TypeError: "type" object is not iterable 

The above exception was the direct cause of the following exception:

Traceback (most recent call last):
    # Traceback removed...
TypeError: Make sure your view"s Permission_classes are iterable. If 
     you use parens () to generate a set with a single element make 
     sure that there is a (comma,) behind the one element.

Turning a totally nondescript TypeError into a nice message with hints towards a solution without messing up the original Exception.

Answer rating: 142

I"d do it like this so changing its type in foo() won"t require also changing it in bar().

def foo():
    try:
        raise IOError("Stuff")
    except:
        raise

def bar(arg1):
    try:
        foo()
    except Exception as e:
        raise type(e)(e.message + " happens at %s" % arg1)

bar("arg1")

Traceback (most recent call last):
  File "test.py", line 13, in <module>
    bar("arg1")
  File "test.py", line 11, in bar
    raise type(e)(e.message + " happens at %s" % arg1)
IOError: Stuff happens at arg1

Update 1

Here"s a slight modification that preserves the original traceback:

...
def bar(arg1):
    try:
        foo()
    except Exception as e:
        import sys
        raise type(e), type(e)(e.message +
                               " happens at %s" % arg1), sys.exc_info()[2]

bar("arg1")

Traceback (most recent call last):
  File "test.py", line 16, in <module>
    bar("arg1")
  File "test.py", line 11, in bar
    foo()
  File "test.py", line 5, in foo
    raise IOError("Stuff")
IOError: Stuff happens at arg1

Update 2

For Python 3.x, the code in my first update is syntactically incorrect plus the idea of having a message attribute on BaseException was retracted in a change to PEP 352 on 2012-05-16 (my first update was posted on 2012-03-12). So currently, in Python 3.5.2 anyway, you"d need to do something along these lines to preserve the traceback and not hardcode the type of exception in function bar(). Also note that there will be the line:

During handling of the above exception, another exception occurred:

in the traceback messages displayed.

# for Python 3.x
...
def bar(arg1):
    try:
        foo()
    except Exception as e:
        import sys
        raise type(e)(str(e) +
                      " happens at %s" % arg1).with_traceback(sys.exc_info()[2])

bar("arg1")

Update 3

A commenter asked if there was a way that would work in both Python 2 and 3. Although the answer might seem to be "No" due to the syntax differences, there is a way around that by using a helper function like reraise() in the six add-on module. So, if you"d rather not use the library for some reason, below is a simplified standalone version.

Note too, that since the exception is reraised within the reraise() function, that will appear in whatever traceback is raised, but the final result is what you want.

import sys

if sys.version_info.major < 3:  # Python 2?
    # Using exec avoids a SyntaxError in Python 3.
    exec("""def reraise(exc_type, exc_value, exc_traceback=None):
                raise exc_type, exc_value, exc_traceback""")
else:
    def reraise(exc_type, exc_value, exc_traceback=None):
        if exc_value is None:
            exc_value = exc_type()
        if exc_value.__traceback__ is not exc_traceback:
            raise exc_value.with_traceback(exc_traceback)
        raise exc_value

def foo():
    try:
        raise IOError("Stuff")
    except:
        raise

def bar(arg1):
    try:
       foo()
    except Exception as e:
        reraise(type(e), type(e)(str(e) +
                                 " happens at %s" % arg1), sys.exc_info()[2])

bar("arg1")




Get Solution for free from DataCamp guru